/*	
 *	clipmisc.c
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001 Naoyuki Sawa
 *
 *	* Wed Dec 12 21:51:29 JST 2001 Naoyuki Sawa
 *	- 쐬JnB
 *	* Thu May 30 22:41:27 JST 2002 Naoyuki Sawa
 *	- die()̏I{^ASTARTSELECTɕύXB
 *	* Sun Jan 26 19:33:00 JST 2003 Naoyuki Sawa
 *	- die()֐̐錾__attribute__((noreturn))ǉ̂ŁA
 *	  x}̂߁Adie()֐̍Ōexit(1)ǉB
 *	  :__attribute__((...))͊֐錾̂ݎw\łB
 *	       ֐Ɏw肷ƃRpCG[ƂȂ܂B
 *	* Sun May 4 18:05:00 JST 2003 Naoyuki Sawa
 *	- fpk_size()/fpk_load()ǉ܂B
 *	  ȑOAzip`̃T|[gǉɁAfpk`̃T|[g͍폜̂łA
 *	  󂫃eʂNzipWJpobt@(32K)Ȃ悤ȏꍇ
 *	  ͂fpk`gƂ̂ŁAfpk`̃T|[gĎ܂B
 *	* Sat Nov 22 06:00:00 JST 2003 Naoyuki Sawa
 *	- g[Xo(TRACE_ON/TRACE/trace())ǉ܂B
 *	* Wed Sep 15 06:36:00 JST 2004 Naoyuki Sawa
 *	- RpCoÔ߁ARND8/16,RND8/16_RANGE}N֐܂B
 *	  ߋ̃\[X̌݊̂߁A֐Ăяo}N`Ă܂B
 */
#include "clip.h"

/*****************************************************************************
 *	ėp}NE֐
 *****************************************************************************/

int
rnd8(int* seed)
{
	/* 8rbg(wZ80}V`̏x) */
	*seed = *seed * 5 + 0x3711;
	return (*seed >> 8) & 0xff;
}

int
rnd16(int* seed)
{
	/* 16rbg(VisualC++ 6.0 \VC98\CRT\SRC\RAND.C Qlɂ܂) */
	*seed = *seed * 214013 + 2531011;
	return (*seed >> 16) & 0xffff;
}

int
rnd8_range(int* seed, int a, int b)
{
	return rnd8(seed) % (b - a) + a;
}

int
rnd16_range(int* seed, int a, int b)
{
	return rnd16(seed) % (b - a) + a;
}

void
shuffle(void* base, int num, int width, int* seed)
{
	int i;
	int c;
	int i_dst;
	int i_src;
	unsigned char* p_dst;
	unsigned char* p_src;

	/* 0vf̔z͕słB܂A
	 * ݂̎16bit𗘗pĂ邽߁A65536vf߂̔zɂ͖ΉłB
	 */
	if((num < 0) || (num > (1<<16))) {
		DIE();
	}

	/* 擪vfŏIvf܂ŏԂ... */
	p_dst = base;
	for(i_dst = 0; i_dst < num; i_dst++) {

		/* ̗vf肵܂B */
		i_src = RND16_RANGE(*seed, i_dst, num);
		p_src = (unsigned char*)base + width * i_src;

		/* 1oCgÂ܂B */
		for(i = 0; i < width; i++) {
			c = *p_dst;
			    *p_dst = *p_src;
			             *p_src = c;
			p_dst++;
			p_src++;
		}
	}
}

/*****************************************************************************
 *	G[
 *****************************************************************************/

void
die(const char* fmt, ...)
{
#ifdef PIECE
	/* as33AZúA`V{externƌȂ̂ŁA
	 * Iextern錾͕Kv܂B(_def_vbuff̂)
	 */
	asm("
	xcall pceLCDDispStop		; pceLCDDispStop();
	xld.w %r12, _def_vbuff		; pceLCDSetBuffer(_def_vbuff);
	xcall pceLCDSetBuffer
	xcall pceLCDDispStart		; pceLCDDispStart();
	xld.w %r12, 0			; pceFontSetType(0);
	xcall pceFontSetType
	xld.w %r12, 3			; pceFontSetTxColor(3);
	xcall pceFontSetTxColor
	xld.w %r12, 0			; pceFontSetBkColor(0);
	xcall pceFontSetBkColor
	xld.w %r12, 0			; pceFontSetPos(0, 0);
	xld.w %r13, 0
	xcall pceFontSetPos
	xld.w %r4, die_L10		; pceFontPrintf(fmt, ...);
	xld.w [%sp], %r4
	xjp pceFontPrintf
die_L10:
	xcall pceLCDTrans		; pceLCDTrans();
die_L20:				; for(;;) {
	xcall yield			;	yield();
	xcall pcePadGet			;	if(pcePadGet() & TRG_SELECT) {
	xand %r10, %r10, 0x4000		;
	xjreq die_L30			;
	xld.w %r12, 1			;		pceAppReqExit(1);
	xcall pceAppReqExit		;
die_L30:				;	}
	xjp die_L20			; }
	");
#else /*PIECE*/
	va_list ap;
	va_start(ap, fmt);
	vfprintf(stderr, fmt, ap);
	va_end(ap);
	fprintf(stderr, "\n");
	abort();
#endif /*PIECE*/
	exit(1); /* __attribute__((noreturn))̌x} */
}

/*****************************************************************************
 *	g[Xo
 *****************************************************************************/

void
trace(const char* fmt, ...)
{
	va_list ap;
	va_start(ap, fmt);
	vfprintf(stderr, fmt, ap);
	va_end(ap);
}

/*****************************************************************************
 *	[eBeBFCӒpPbgL[
 *****************************************************************************/

QUEUE*
create_queue(int capacity)
{
	QUEUE* queue;

	if(capacity < 0) {
		DIE();
	}

	/* pPbgTCYi[psizeof(int)ZāAۂ̃Xg[WTCYƂ܂B
	 * őŁAcapacityoCg̃pPbgAL[Ɋi[ł悤ɂ邽߂łB
	 */
	capacity += sizeof(int);

	/* wb_ƃXg[W̃mۂ܂B */
	queue = malloc(sizeof(QUEUE) + capacity);
	if(!queue) {
		DIE(); /* s */
	}

	/* wb_܂B */
	queue->capacity = capacity;
	queue->size = 0;

	return queue;
}

void
delete_queue(QUEUE* queue)
{
	/* wb_ƃXg[W̃J܂B */
	free(queue);
}

void
clear_queue(QUEUE* queue)
{
	queue->size = 0;
}

int
write_queue(QUEUE* queue, const void* packet/*[length]*/, int length)
{
	unsigned char* storage = (unsigned char*)(queue + 1);

	if(length < 0) {
		DIE();
	}

	/* pPbgTCYƃpPbgf[^ǉ󂫗eʂ邩H */
	if((int)(queue->size + (sizeof(int) + length)) > queue->capacity) {
		return -1;
	}

	/* L[̖ɃpPbgTCYƃpPbgf[^ǉ܂B */
	PUT_LEWORD(storage + queue->size, length);
	memcpy(storage + queue->size + sizeof(int), packet, length);
	queue->size += (sizeof(int) + length);

	return length;
}

int
read_queue(QUEUE* queue, void* packet/*[maxlength]*/, int maxlength)
{
	unsigned char* storage = (unsigned char*)(queue + 1);
	int length;

	if(maxlength < 0) {
		DIE();
	}

	/* L[łȂH */
	if(!queue->size) {
		return -1;
	}

	/* L[̐擪̃pPbgTCY擾܂B */
	if(queue->size < sizeof(int)) {
		DIE(); /* L[jH */
	}
	length = LEWORD(storage);
	if((length < 0) || ((int)(sizeof(int) + length) > queue->size)) {
		DIE(); /* L[jH */
	}

	/* w肳ꂽ̈Ɋi[ł邩H */
	if(length > maxlength) {
		return -1;
	}

	/* L[̐擪̃pPbgAw肳ꂽ̈ɃRs[܂B
	 * Apacket=NULLȂ΁AǂݏopPbgf[^j܂B
	 */
	if(packet) {
		memcpy(packet, storage + sizeof(int), length);
	}

	/* L[̐擪̃pPbg폜A̕AL[l߂܂B */
	queue->size -= (sizeof(int) + length);
	memmove(storage, storage + (sizeof(int) + length), queue->size);

	return length;
}

const void*
peek_queue(QUEUE* queue, int* _length)
{
	unsigned char* storage = (unsigned char*)(queue + 1);
	int length;

	/* L[󂩁H */
	if(!queue->size) {
		return NULL;
	}

	/* L[̐擪̃pPbgTCY擾܂B */
	if(queue->size < sizeof(int)) {
		DIE(); /* L[jH */
	}
	length = LEWORD(storage);
	if((length < 0) || ((int)(sizeof(int) + length) > queue->size)) {
		DIE(); /* L[jH */
	}

	/* pPbgTCYi[܂B */
	if(_length) {
		*_length = length;
	}

	/* pPbgf[^̐擪AhXԂ܂B */
	return storage + sizeof(int);
}

int
queue_space(QUEUE* queue)
{
	int space = queue->capacity - queue->size - sizeof(int);
	if(space < 0) {
		space = 0;
	}
	return space;
}

/*****************************************************************************
 *	[eBeBFOobt@
 *****************************************************************************/

BUFFER*
create_buffer(int capacity)
{
	BUFFER* buffer;

	if(capacity < 0) {
		DIE();
	}

	/* wb_ƃXg[W̃mۂ܂B */
	buffer = malloc(sizeof(BUFFER) + capacity);
	if(!buffer) {
		DIE(); /* s */
	}

	/* wb_܂B */
	buffer->capacity = capacity;
	buffer->size = 0;

	return buffer;
}

void
delete_buffer(BUFFER* buffer)
{
	/* wb_ƃXg[W̃J܂B */
	free(buffer);
}

void
clear_buffer(BUFFER* buffer)
{
	buffer->size = 0;
}

int
write_buffer(BUFFER* buffer, const void* data/*[length]*/, int length)
{
	unsigned char* storage = (unsigned char*)(buffer + 1);

	if(length < 0) {
		DIE();
	}

	/* ރf[^AXg[W̋󂫗eʂ֐؂l߂܂B */
	if(length > (buffer->capacity - buffer->size)) {
		length = (buffer->capacity - buffer->size);
	}

	/* Xg[WցAf[^݂܂B */
	memcpy(storage + buffer->size, data, length);
	buffer->size += length;

	/* ۂɏ񂾃f[^Ԃ܂B */
	return length;
}

int
read_buffer(BUFFER* buffer, void* data/*[maxlength]*/, int maxlength)
{
	unsigned char* storage = (unsigned char*)(buffer + 1);
	int length;

	if(maxlength < 0) {
		DIE();
	}

	/* ǂݏof[^Aw肳ꂽ̈TCY֐؂l߂܂B */
	length = maxlength < buffer->size
	       ? maxlength : buffer->size;

	/* Xg[W擪̃f[^Aw肳ꂽ̈ɃRs[܂B
	 * Adata=NULLȂ΁Aǂݏof[^j܂B
	 */
	if(data) {
		memcpy(data, storage, length);
	}

	/* Xg[W擪̃f[^폜A̕AXg[Wl߂܂B */
	buffer->size -= length;
	memmove(storage, storage + length, buffer->size);

	/* ۂɓǂݏof[^Ԃ܂B */
	return length;
}

const void*
peek_buffer(BUFFER* buffer, int* length)
{
	/* f[^i[܂B */
	if(length) {
		*length = buffer->size;
	}

	/* Xg[W̐擪AhXԂ܂B */
	return buffer + 1;
}

int
buffer_space(BUFFER* buffer)
{
	/* ݉\ȍőf[^́AXg[W̋󂫗eʂłB */
	return buffer->capacity - buffer->size;
}

/*****************************************************************************
 *	[eBeBF_uNXg
 *****************************************************************************/

void
InitializeListHead(LIST_ENTRY* ListHead)
{
	ListHead->Flink = ListHead->Blink = ListHead;
}

int
IsListEmpty(LIST_ENTRY* ListHead)
{
	return ListHead->Flink == ListHead;
}

LIST_ENTRY*
RemoveHeadList(LIST_ENTRY* ListHead)
{
	LIST_ENTRY* Head = ListHead->Flink;
	RemoveEntryList(Head);
	return Head;
}

LIST_ENTRY*
RemoveTailList(LIST_ENTRY* ListHead)
{
	LIST_ENTRY* Tail = ListHead->Blink;
	RemoveEntryList(Tail);
	return Tail;
}

void
RemoveEntryList(LIST_ENTRY* Entry)
{
	LIST_ENTRY* Flink = Entry->Flink;
	LIST_ENTRY* Blink = Entry->Blink;
	Blink->Flink = Flink;
	Flink->Blink = Blink;
}

void
InsertHeadList(LIST_ENTRY* ListHead, LIST_ENTRY* Entry)
{
	LIST_ENTRY* Head = ListHead->Flink;
	Entry->Flink = Head;
	Entry->Blink = ListHead;
	ListHead->Flink = Head->Blink = Entry;
}

void
InsertTailList(LIST_ENTRY* ListHead, LIST_ENTRY* Entry)
{
	LIST_ENTRY* Tail = ListHead->Blink;
	Entry->Flink = ListHead;
	Entry->Blink = Tail;
	Tail->Flink = ListHead->Blink = Entry;
}

/*****************************************************************************
 *	[eBeBFt@CpbN`
 *****************************************************************************/

static int
fpk_find(FILE* fp, const char* name, FILE_INFO* fi)
{
	int retval, i;
	FILE_PAC_INFO pi;

	/* fpkǂ݂܂B */
	/* ĂяoɃt@Cʒu擪ł邱ƁB̊֐rewind()܂B */
	retval = fread(&pi, 1, sizeof pi, fp);
	if(retval != sizeof pi) DIE();
	if(pi.head != FILE_PAC_INFO_HEAD) DIE(); /* VOl` */

	/* t@C𑖍āc */
	for(i = 0; i < pi.famount; i++) {
		/* t@Cǂ݂܂B */
		retval = fread(fi, 1, sizeof *fi, fp);
		if(retval != sizeof *fi) DIE();

		/* H */
		if(strncasecmp(fi->fname, name, sizeof fi->fname) == 0) break;
	}

	return i < pi.famount; /* 1:/0:Ȃ */
}

int
fpk_size(const char* fname, const char* name)
{
	int retval;
	FILE* fp;
	FILE_INFO fi;

	/* fpkt@CJ܂B */
	fp = fopen(fname, "rb");
	if(fp == NULL) DIE();

	/* t@CT܂B */
	retval = fpk_find(fp, name, &fi);
	if(!retval) DIE();

	/* fpkt@C܂B */
	fclose(fp);

	return fi.size;
}

int
fpk_load(const char* fname, const char* name, void* buffer, int buflen)
{
	int retval;
	FILE* fp;
	FILE_INFO fi;

	/* fpkt@CJ܂B */
	fp = fopen(fname, "rb");
	if(fp == NULL) DIE();

	/* t@CT܂B */
	retval = fpk_find(fp, name, &fi);
	if(!retval) DIE();
	if(fi.size > buflen) DIE(); /* obt@s */

	/* t@Cǂݍ݂܂B */
	retval = fseek(fp, fi.offset, SEEK_SET);
	if(retval != 0) DIE();
	retval = fread(buffer, 1, fi.size, fp);
	if(retval != fi.size) DIE();

	/* fpkt@C܂B */
	fclose(fp);

	return fi.size; /* ǂݍ񂾃TCYԂ܂ */
}

/*****************************************************************************
 *	[eBeBFIt@CpbN`
 *****************************************************************************/

const void*
fpk_address(const void* fpk, const char* name, int* size)
{
	int i;
	unsigned char* base;
	FILE_PAC_INFO* pi;
	FILE_INFO* fi;

	base = (unsigned char*)fpk;

	/* VOl`܂B */
	pi = (FILE_PAC_INFO*)(base + 0);
	if(pi->head != FILE_PAC_INFO_HEAD) DIE();

	/* t@CGgT܂B */
	fi = (FILE_INFO*)(base + sizeof(FILE_PAC_INFO));
	for(i = 0; i < pi->famount; i++) {
		if(strncasecmp(fi->fname, name, sizeof fi->fname) == 0) break;
		fi++;
	}
	if(i == pi->famount) DIE();

	/* t@CTCYi[܂B */
	if(size) *size = fi->size;

	/* t@C̐擪AhXԂ܂B */
	return base + fi->offset;
}

